;;;;;;;;;;;;;;;;;
;; Version 1.1 ;;
;;;;;;;;;;;;;;;;;

(define (script-fu-Black&White img InLayer filter film InGrain GrainStrength InFlatten)
	
; Save history			
	(gimp-image-undo-group-start img)
;
	(let*	(
		(bw-layer (car (gimp-layer-copy InLayer TRUE)))
		(grainlayer)
		(grainmask)
		(bw2-layer)
		)
		(gimp-image-add-layer img bw-layer -1)

; Select filter type
		(cond
			; Yellow Filter	
			    	((= filter 1)
				    (gimp-hue-saturation bw-layer 0 -5 0 33))	
		    	; Orange Filter	
			    	((= filter 2)
				    (gimp-hue-saturation bw-layer 0 -20 0 25))
			; Red Filter	
			    	((= filter 3)
				    (gimp-hue-saturation bw-layer 0 -41 0 25))
			; Green Filter
			    	((= filter 4)
				    (gimp-hue-saturation bw-layer 0 90 0 33))
			; Blue Filter
			    	((= filter 5)
				    (gimp-hue-saturation bw-layer 0 -145 0 25))
		)

; Select conversion type
		(cond
			; Generic BW
			    	((= film 0) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.24 0.68 0.08 0.24 0.68 0.08 0.24 0.68 0.08 ))
			; Normal Contrast
			    	((= film 1) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.43 0.33 0.30 0.43 0.33 0.30 0.43 0.33 0.30 ))
			; High Contrast
			    	((= film 2) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.40 0.34 0.60 0.40 0.34 0.60 0.40 0.34 0.60 ))
			; 50-50
			    	((= film 3) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.5 0.5 0.00 0.0 0.5 0.5 0.00 0.0 0.5 0.5 0.00 0.0 ))
			; Agfa 200X
			    	((= film 4) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.18 0.41 0.41 0.18 0.41 0.41 0.18 0.41 0.41 ))
			; Agfapan 25
			    	((= film 5) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.25 0.39 0.36 0.25 0.39 0.36 0.25 0.39 0.36 ))
			; Agfapan 100
			    	((= film 6) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.21 0.40 0.39 0.21 0.40 0.39 0.21 0.40 0.39 ))
			; Agfapan 400
			    	((= film 7) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.20 0.41 0.39 0.20 0.41 0.39 0.20 0.41 0.39 ))
			; Ilford Delta 100
			    	((= film 8) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.21 0.42 0.37 0.21 0.42 0.37 0.21 0.42 0.37 ))
			; Ilford Delta 400
			    	((= film 9) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.22 0.42 0.36 0.22 0.42 0.36 0.22 0.42 0.36 ))
			; Ilford Delta 400 Pro & 3200
			    	((= film 10) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.31 0.36 0.33 0.31 0.36 0.33 0.31 0.36 0.33 ))
			; Ilford FP4
			    	((= film 11) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.28 0.41 0.31 0.28 0.41 0.31 0.28 0.41 0.31 ))
			; Ilford HP5
			    	((= film 12) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.23 0.37 0.40 0.23 0.37 0.40 0.23 0.37 0.40 ))
			; Ilford Pan F
			    	((= film 13) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.33 0.36 0.31 0.33 0.36 0.31 0.33 0.36 0.31 ))
			; Ilford SFX
			    	((= film 14) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.36 0.31 0.33 0.36 0.31 0.33 0.36 0.31 0.33 ))
			; Ilford XP2 Super
			    	((= film 15) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.21 0.42 0.37 0.21 0.42 0.37 0.21 0.42 0.37 ))
			; Kodak Tmax 100
			    	((= film 16) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.24 0.37 0.39 0.24 0.37 0.39 0.24 0.37 0.39 ))
			; Kodak Tmax 400
			    	((= film 17) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.27 0.36 0.37 0.27 0.36 0.37 0.27 0.36 0.37 ))
			; Kodak Tri-X
			    	((= film 18) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 0.25 0.35 0.40 0.25 0.35 0.40 0.25 0.35 0.40 ))
			; Kodak HIE
			    	((= film 19) (plug-in-colors-channel-mixer 1 img bw-layer TRUE 1.0 1.0 -1.0 0.0 1.0 1.0 -1.0 0.0 1.0 1.0 -1.0 0.0 ))
			; Lithographic
				((= film 20)
					(begin
						(plug-in-colors-channel-mixer TRUE img bw-layer TRUE 0.4 0.3 0.3 0 0 0 0 0 0)
						(gimp-brightness-contrast bw-layer 0 110)
					)
				)
			; Orthochromatic
				((= film 21) (plug-in-colors-channel-mixer TRUE img bw-layer TRUE -1.1 1.05 1.05 0 0 0 0 0 0))
		)

; Add Film Grain, if we need to
		(if (= InGrain TRUE) 	
			(begin	
				(set! grainlayer (car (gimp-layer-copy bw-layer TRUE)))					
;				
				(gimp-image-add-layer img grainlayer -1)
				(gimp-invert bw-layer)
				(gimp-desaturate-full bw-layer 0)
;
				(set! grainmask (car (gimp-layer-create-mask grainlayer 0)))
;				
				(gimp-layer-add-mask grainlayer grainmask)
				(plug-in-rgb-noise 1 InImage grainmask 1 1 (/ GrainStrength 35) (/ GrainStrength 35) (/ GrainStrength 35) (/ GrainStrength 35))
				(plug-in-despeckle 1 img grainmask 1 1 2 248)
				(gimp-layer-get-apply-mask grainlayer)
;				
				(set! bw2-layer (car (gimp-image-merge-down img grainlayer CLIP-TO-IMAGE)))
;
				(gimp-brightness-contrast bw2-layer 0 (* GrainStrength 4))
			)
		)

; Flatten the image, if we need to
		(cond
			((= InGrain TRUE)
				(cond	
					((= InFlatten TRUE) (gimp-image-merge-down img bw2-layer CLIP-TO-IMAGE))
					((= InFlatten FALSE)
						(begin
							(gimp-drawable-set-name bw2-layer "BlackWhite")
							(gimp-image-set-active-layer img InLayer)
						)
					)
				)
			)
			((= InGrain FALSE)
				(cond	
					((= InFlatten TRUE) (gimp-image-merge-down img bw-layer CLIP-TO-IMAGE))
					((= InFlatten FALSE)
						(begin
							(gimp-drawable-set-name bw-layer "BlackWhite")
							(gimp-image-set-active-layer img InLayer)
						)
					)
				)
			)
		)
	)

; Finish work
	(gimp-image-undo-group-end img)
	(gimp-displays-flush)
)

; Register the function with the GIMP
(script-fu-register
	"script-fu-Black&White"
	_"Black and _White"
	"Black and White conversions"
	"Paul Wagner"
	"No Copyright"
	"3.03.2008"
	"RGB*"
	SF-IMAGE	"The Image"	0
	SF-DRAWABLE	"The Layer"	0
	SF-OPTION	"Film"
			'(
					"Generic BW"
					"Normal Contrast"
					"High Contrast"
					"50/50"
					"Agfa 200X" 
					"Agfapan 25"
					"Agfapan 100"
					"Agfapan 400"
					"Ilford Delta 100"
					"Ilford Delta 400"
					"Ilford Delta 400 Pro & 3200"
					"Ilford FP4"
					"Ilford HP5"
					"Ilford Pan F"
					"Ilford SFX"
					"Ilford XP2 Super"
					"Kodak Tmax 100"
					"Kodak Tmax 400"
					"Kodak Tri-X"
					"Kodak HIE"
					"Lithographic"
					"Orthochromatic"
			)			
	SF-OPTION 	"Filter" 
			'( 		
					"Select"
					"Yellow"
					"Orange" 
					"Red"
					"Green"
					"Blue"
			)
	SF-TOGGLE	"Film Grain" FALSE
	SF-ADJUSTMENT	"Film Grain Strength" '(3.0 1.0 6.0 0.1 0 1 0)
	SF-TOGGLE	"Flatten Image"	FALSE
)
;
(script-fu-menu-register "script-fu-Black&White"
			 "<Image>/Photo/Effects/Simulations")
;
