;;;;;;;;;;;;;;;;;
;; Version 1.1 ;;
;;;;;;;;;;;;;;;;;

(define (script-fu-HighPassSharpen InImage InLayer Strength InDespeckle InFlatten)

; Save history			

	(gimp-image-undo-group-start InImage)
;
	(let*	(
		(Temp1Layer (car (gimp-layer-copy InLayer TRUE)))
		(Temp2Layer (car (gimp-layer-copy InLayer TRUE)))
		)
;
		(gimp-image-add-layer InImage Temp1Layer -1)
		(gimp-image-add-layer InImage Temp2Layer -1)
;
 		(plug-in-gauss TRUE InImage Temp2Layer (+ 5 (* Strength 1.75)) (+ 5 (* Strength 1.75)) TRUE)
		(gimp-invert Temp2Layer)
		(gimp-layer-set-opacity Temp2Layer 50)
;
		(let*	(
			(SharpenLayer (car (gimp-image-merge-down InImage Temp2Layer CLIP-TO-IMAGE)))
			)
;
			(gimp-desaturate-full SharpenLayer 0)
			(gimp-levels SharpenLayer HISTOGRAM-VALUE (+ 80 (* 8.0 Strength)) (- 255 (+ 80 (* 8.0 Strength))) 1.0 0 255)

; Despeckle the Layer, if we need to			

			(if (= InDespeckle TRUE) (plug-in-despeckle 1 InImage SharpenLayer 2 1 5 248))
;				
			(gimp-layer-set-mode SharpenLayer OVERLAY-MODE)
			(gimp-layer-set-opacity SharpenLayer 60.0)	

; Flatten the image, if we need to

			(cond
				((= InFlatten TRUE) (gimp-image-merge-down InImage SharpenLayer CLIP-TO-IMAGE))
				((= InFlatten FALSE) 
					(begin
						(gimp-drawable-set-name SharpenLayer "Highpass Sharpened")
						(gimp-image-set-active-layer InImage InLayer)
					)
				)
			)
		)
	)

; Finish work

	(gimp-image-undo-group-end InImage)
	(gimp-displays-flush)
)
;
(script-fu-register 
	"script-fu-HighPassSharpen"
	_"Highpass Sharpen"
	"Highpass Filter Sharpening"
	"Unknown"
	"No Copyright"
	"3.3.2008"
	"RGB* GRAY*"
	SF-IMAGE	"The Image"	0
	SF-DRAWABLE	"The Layer"	0
	SF-ADJUSTMENT	"Sharpening Strength"	'(2.0 0.1 5.0 0.1 0 1 0)
	SF-TOGGLE	"Despeckle"	FALSE
	SF-TOGGLE	"Flatten Image"	FALSE
)
;
(script-fu-menu-register "script-fu-HighPassSharpen"
			 "<Image>/Photo/Sharpen")
;
