;;;;;;;;;;;;;;;;;
;; Version 1.0 ;;
;;;;;;;;;;;;;;;;;

(define (script-fu-film-grain2 InImage InLayer GrainStrength InFlatten)

; Save history			
	(gimp-image-undo-group-start InImage)
;
	(let*	(
		(bw-layer (car (gimp-layer-copy InLayer TRUE)))
		(grainlayer)
		(grainmask)
		(bw2-layer)
		)
;		
		(gimp-image-add-layer InImage bw-layer -1)

		(set! grainlayer (car (gimp-layer-copy bw-layer TRUE)))					
;				
		(gimp-image-add-layer InImage grainlayer -1)
		(gimp-invert bw-layer)
		(gimp-desaturate-full bw-layer 0)
		
		(set! grainmask (car (gimp-layer-create-mask grainlayer 0)))
;				
		(gimp-layer-add-mask grainlayer grainmask)
		(plug-in-rgb-noise 1 InImage grainmask 1 1 (/ GrainStrength 35) (/ GrainStrength 35) (/ GrainStrength 35) (/ GrainStrength 35))
		(plug-in-despeckle 1 InImage grainmask 1 1 2 248)
		(gimp-layer-get-apply-mask grainlayer)
;				
		(set! bw2-layer (car (gimp-image-merge-down InImage grainlayer CLIP-TO-IMAGE)))
;
		(gimp-brightness-contrast bw2-layer 0 (* GrainStrength 4))

; Flatten the image, if we need to
		
		(cond
			((= InFlatten TRUE) (gimp-image-merge-down InImage bw2-layer CLIP-TO-IMAGE))
			((= InFlatten FALSE) 
				(begin
					(gimp-drawable-set-name bw2-layer "Film Grain")
					(gimp-image-set-active-layer InImage InLayer)
				
				)
			)
		)
	)

; Finish work
	(gimp-image-undo-group-end InImage)
	(gimp-displays-flush)
)

; Register the function with the GIMP
(script-fu-register
	"script-fu-film-grain2"
	_"Film Grain"
	"Film Grain Simulation"
	"Paul Wagner"
	"No Copyright"
	"4.03.2008"
	"RGB*"
	SF-IMAGE	"The Image"	0
	SF-DRAWABLE	"The Layer"	0
	SF-ADJUSTMENT	"Film Grain Strength" '(3.0 1.0 6.0 0.1 0 1 0)
	SF-TOGGLE	"Flatten Image" FALSE
)
;
(script-fu-menu-register "script-fu-film-grain2"
			 "<Image>/Photo/Effects")
;
