; original script by kward1979uk
; modified by Paul Sherman for GIMP 2.4 11/22/2007
; distributed by gimphelp.org
;
  (define (set-pt a index x y)
      (begin
          (aset a (* index 2) x)
          (aset a (+ (* index 2) 1) y)
       )
  )
  
(define (spline-sketch)
  (let*
	((a (make-vector 18 'byte)))
	(set-pt a 0 0 0)
	(set-pt a 1 190 0)
	(set-pt a 2 191 1)
	(set-pt a 3 210 210)
	(set-pt a 4 220 220)
	(set-pt a 5 230 230)
	(set-pt a 6 240 240)
	(set-pt a 7 250 250)
	(set-pt a 8 255 255)
	
a))

(define (sketch inimage indraw bg-colour)

(define theImage inimage)
(define theDraw indraw)
(gimp-image-undo-group-start theImage)
(define height (car (gimp-drawable-height theDraw)))
(define width (car (gimp-drawable-width theDraw)))

(plug-in-edge 1 theImage theDraw 2 1 0)
(gimp-equalize theDraw 0)
(gimp-desaturate theDraw)
(define highpass (car (gimp-layer-copy theDraw 1)))
(gimp-image-add-layer theImage highpass 1)
(gimp-curves-spline highpass 0 18 (spline-sketch))
(gimp-invert theDraw)
(gimp-layer-add-alpha theDraw)
(define imagemask (car (gimp-layer-create-mask theDraw 0)))
(gimp-layer-add-mask theDraw imagemask)
(gimp-edit-copy highpass)
(define copy-paste (car (gimp-edit-paste imagemask 0)))
(gimp-floating-sel-anchor copy-paste)
(gimp-context-set-background bg-colour)
(define background (car (gimp-layer-new theImage width height 1 "background" 100 0)))
(gimp-drawable-fill background 1)
(gimp-image-add-layer theImage background 0)
(gimp-image-remove-layer theImage highpass)
(gimp-image-lower-layer theImage background)

(gimp-image-undo-group-end theImage)
(gimp-displays-flush)
)
(script-fu-register 	"sketch"
			"<Image>/Photo/Effects/Artistic/Line Sketch"
			"Turns a image into a sketch if the image is a alpha layer it must be flatterned first"
			"Karl Ward"
			"Karl Ward"
			"Feb 2006"
			"RGB*"
			SF-IMAGE      	"SF-IMAGE" 0
			SF-DRAWABLE   	"SF-DRAWABLE" 0
			SF-COLOR	"Background Colour" '(255 255 255)
			
)
				
